<?php
/* Autor...:  */
/* Esquema.: SR_DevolucionFacturacion.xml */
/* Generado: 2021-07-04 00:45:36 */

/* Metodos de acceso a los campos de la tabla SR_DevolucionFacturacion */
abstract class BaseSR_DevolucionFacturacionBN
{
    /* Campos de la tabla */
    private $i_DevolFactId;    // DevolFactId: ( no definido )
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $i_IdSucursal;    // IdSucursal: ( no definido )
    private $i_IdProyecto;    // IdProyecto: ( no definido )
    private $i_IdPersona;    // IdPersona: ( no definido )
    private $s_GrupoId;    // GrupoId: ( no definido )
    private $s_TipoEstado;    // TipoEstado: ( no definido )
    private $s_EstadoDesc;    // EstadoDesc: ( no definido )
    private $s_IdItem;    // IdItem: ( no definido )
    private $s_DescripcionItem;    // DescripcionItem: ( no definido )
    private $d_FechaCorte;    // FechaCorte: ( no definido )
    private $f_SubTotal;    // SubTotal: ( no definido )
    private $f_MontoIGV;    // MontoIGV: ( no definido )
    private $f_MontoTotal;    // MontoTotal: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $s_IdTipoDocumento;    // IdTipoDocumento: ( no definido )
    private $s_NumeroDocumento;    // NumeroDocumento: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )

    /* Establece el valor del campo DevolFactId */
    public function setDevolFactId( $i_DevolFactId )
    {
        $this->i_DevolFactId = $i_DevolFactId;
    }

    /* Obtiene el valor del campo DevolFactId */
    public function getDevolFactId()
    {
        return $this->i_DevolFactId;
    }

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo IdSucursal */
    public function setIdSucursal( $i_IdSucursal )
    {
        $this->i_IdSucursal = $i_IdSucursal;
    }

    /* Obtiene el valor del campo IdSucursal */
    public function getIdSucursal()
    {
        return $this->i_IdSucursal;
    }

    /* Establece el valor del campo IdProyecto */
    public function setIdProyecto( $i_IdProyecto )
    {
        $this->i_IdProyecto = $i_IdProyecto;
    }

    /* Obtiene el valor del campo IdProyecto */
    public function getIdProyecto()
    {
        return $this->i_IdProyecto;
    }

    /* Establece el valor del campo IdPersona */
    public function setIdPersona( $i_IdPersona )
    {
        $this->i_IdPersona = $i_IdPersona;
    }

    /* Obtiene el valor del campo IdPersona */
    public function getIdPersona()
    {
        return $this->i_IdPersona;
    }

    /* Establece el valor del campo GrupoId */
    public function setGrupoId( $s_GrupoId )
    {
        $this->s_GrupoId = $s_GrupoId;
    }

    /* Obtiene el valor del campo GrupoId */
    public function getGrupoId()
    {
        return $this->s_GrupoId;
    }

    /* Establece el valor del campo TipoEstado */
    public function setTipoEstado( $s_TipoEstado )
    {
        $this->s_TipoEstado = $s_TipoEstado;
    }

    /* Obtiene el valor del campo TipoEstado */
    public function getTipoEstado()
    {
        return $this->s_TipoEstado;
    }

    /* Establece el valor del campo EstadoDesc */
    public function setEstadoDesc( $s_EstadoDesc )
    {
        $this->s_EstadoDesc = $s_EstadoDesc;
    }

    /* Obtiene el valor del campo EstadoDesc */
    public function getEstadoDesc()
    {
        return $this->s_EstadoDesc;
    }

    /* Establece el valor del campo IdItem */
    public function setIdItem( $s_IdItem )
    {
        $this->s_IdItem = $s_IdItem;
    }

    /* Obtiene el valor del campo IdItem */
    public function getIdItem()
    {
        return $this->s_IdItem;
    }

    /* Establece el valor del campo DescripcionItem */
    public function setDescripcionItem( $s_DescripcionItem )
    {
        $this->s_DescripcionItem = $s_DescripcionItem;
    }

    /* Obtiene el valor del campo DescripcionItem */
    public function getDescripcionItem()
    {
        return $this->s_DescripcionItem;
    }

    /* Establece el valor del campo FechaCorte */
    public function setFechaCorte( $d_FechaCorte )
    {
        $this->d_FechaCorte = $d_FechaCorte;
    }

    /* Obtiene el valor del campo FechaCorte */
    public function getFechaCorte()
    {
        return $this->d_FechaCorte;
    }

    /* Establece el valor del campo SubTotal */
    public function setSubTotal( $f_SubTotal )
    {
        $this->f_SubTotal = $f_SubTotal;
    }

    /* Obtiene el valor del campo SubTotal */
    public function getSubTotal()
    {
        return $this->f_SubTotal;
    }

    /* Establece el valor del campo MontoIGV */
    public function setMontoIGV( $f_MontoIGV )
    {
        $this->f_MontoIGV = $f_MontoIGV;
    }

    /* Obtiene el valor del campo MontoIGV */
    public function getMontoIGV()
    {
        return $this->f_MontoIGV;
    }

    /* Establece el valor del campo MontoTotal */
    public function setMontoTotal( $f_MontoTotal )
    {
        $this->f_MontoTotal = $f_MontoTotal;
    }

    /* Obtiene el valor del campo MontoTotal */
    public function getMontoTotal()
    {
        return $this->f_MontoTotal;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo IdTipoDocumento */
    public function setIdTipoDocumento( $s_IdTipoDocumento )
    {
        $this->s_IdTipoDocumento = $s_IdTipoDocumento;
    }

    /* Obtiene el valor del campo IdTipoDocumento */
    public function getIdTipoDocumento()
    {
        return $this->s_IdTipoDocumento;
    }

    /* Establece el valor del campo NumeroDocumento */
    public function setNumeroDocumento( $s_NumeroDocumento )
    {
        $this->s_NumeroDocumento = $s_NumeroDocumento;
    }

    /* Obtiene el valor del campo NumeroDocumento */
    public function getNumeroDocumento()
    {
        return $this->s_NumeroDocumento;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'DevolFactId' => $this->getDevolFactId(),
            'IdCompania' => $this->getIdCompania(),
            'IdSucursal' => $this->getIdSucursal(),
            'IdProyecto' => $this->getIdProyecto(),
            'IdPersona' => $this->getIdPersona(),
            'GrupoId' => $this->getGrupoId(),
            'TipoEstado' => $this->getTipoEstado(),
            'EstadoDesc' => $this->getEstadoDesc(),
            'IdItem' => $this->getIdItem(),
            'DescripcionItem' => $this->getDescripcionItem(),
            'FechaCorte' => $this->getFechaCorte(),
            'SubTotal' => $this->getSubTotal(),
            'MontoIGV' => $this->getMontoIGV(),
            'MontoTotal' => $this->getMontoTotal(),
            'Estado' => $this->getEstado(),
            'IdTipoDocumento' => $this->getIdTipoDocumento(),
            'NumeroDocumento' => $this->getNumeroDocumento(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto SR_DevolucionFacturacionBN desde un RecordSet */
    public static function retrieveByRs( $o_SR_DevolucionFacturacionRs )
    {
        $o_SR_DevolucionFacturacionBN = new SR_DevolucionFacturacionBN();
        $o_SR_DevolucionFacturacionBN->setDevolFactId( ( integer ) $o_SR_DevolucionFacturacionRs[ "DevolFactId" ] );
        $o_SR_DevolucionFacturacionBN->setIdCompania( ( integer ) $o_SR_DevolucionFacturacionRs[ "IdCompania" ] );
        $o_SR_DevolucionFacturacionBN->setIdSucursal( ( integer ) $o_SR_DevolucionFacturacionRs[ "IdSucursal" ] );
        $o_SR_DevolucionFacturacionBN->setIdProyecto( ( integer ) $o_SR_DevolucionFacturacionRs[ "IdProyecto" ] );
        $o_SR_DevolucionFacturacionBN->setIdPersona( ( integer ) $o_SR_DevolucionFacturacionRs[ "IdPersona" ] );
        $o_SR_DevolucionFacturacionBN->setGrupoId( $o_SR_DevolucionFacturacionRs[ "GrupoId" ] );
        $o_SR_DevolucionFacturacionBN->setTipoEstado( $o_SR_DevolucionFacturacionRs[ "TipoEstado" ] );
        $o_SR_DevolucionFacturacionBN->setEstadoDesc( $o_SR_DevolucionFacturacionRs[ "EstadoDesc" ] );
        $o_SR_DevolucionFacturacionBN->setIdItem( $o_SR_DevolucionFacturacionRs[ "IdItem" ] );
        $o_SR_DevolucionFacturacionBN->setDescripcionItem( $o_SR_DevolucionFacturacionRs[ "DescripcionItem" ] );
        $o_SR_DevolucionFacturacionBN->setFechaCorte( utilTimestamp::getTimestamp( $o_SR_DevolucionFacturacionRs[ "FechaCorte" ], "Y-m-d" ) );
        $o_SR_DevolucionFacturacionBN->setSubTotal( ( float ) $o_SR_DevolucionFacturacionRs[ "SubTotal" ] );
        $o_SR_DevolucionFacturacionBN->setMontoIGV( ( float ) $o_SR_DevolucionFacturacionRs[ "MontoIGV" ] );
        $o_SR_DevolucionFacturacionBN->setMontoTotal( ( float ) $o_SR_DevolucionFacturacionRs[ "MontoTotal" ] );
        $o_SR_DevolucionFacturacionBN->setEstado( $o_SR_DevolucionFacturacionRs[ "Estado" ] );
        $o_SR_DevolucionFacturacionBN->setIdTipoDocumento( $o_SR_DevolucionFacturacionRs[ "IdTipoDocumento" ] );
        $o_SR_DevolucionFacturacionBN->setNumeroDocumento( $o_SR_DevolucionFacturacionRs[ "NumeroDocumento" ] );
        $o_SR_DevolucionFacturacionBN->setUsuarioCreacion( $o_SR_DevolucionFacturacionRs[ "UsuarioCreacion" ] );
        $o_SR_DevolucionFacturacionBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_SR_DevolucionFacturacionRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_SR_DevolucionFacturacionBN->setUsuarioModificacion( $o_SR_DevolucionFacturacionRs[ "UsuarioModificacion" ] );
        $o_SR_DevolucionFacturacionBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_SR_DevolucionFacturacionRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        return $o_SR_DevolucionFacturacionBN;
    }
}
?>